##// END OF EJS Templates
Merge branch 'ref+fix' of https://github.com/burnbabyburn/rpi23-gen-image into ref+fix
burnbabyburn -
r316:2b270da25eca Fusion
parent child
Show More
@@ -1,49 +1,53
1 1 #!/bin/bash
2 2 #
3 3 # Setup APT repositories
4 4 #
5 5
6 6 # Load utility functions
7 7 . ./functions.sh
8 8
9 9 # Install and setup APT proxy configuration
10 10 if [ -z "$APT_PROXY" ] ; then
11 11 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
12 12 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
13 13 fi
14 14
15 15 if [ "$BUILD_KERNEL" = false ] ; then
16 16 echo "Downloading precompiled kernel"
17 17 echo "error: not configured"
18 18 exit 1;
19 else # BUILD_KERNEL=true
19 # BUILD_KERNEL=true
20 else
21 echo "No precompiled kernel repositories were added"
22 fi
23
20 24 #autconfigure best apt server to not spam ftp.debian.org
21 25 #rm files/apt/sources.list
22 26 #netselect-apt does not know buster yet
23 27 if [ "$RELEASE" = "buster" ] ; then
24 28 RELEASE=${RELEASE:=testing}
25 29 fi
26 netselect_string=${netselect_string:=""}
30
27 31 if [ "$ENABLE_NONFREE" = true ] ; then
28 netselect-apt --arch "$RELEASE_ARCH" --sources "$netselect_string" --outfile "${ETC_DIR}/apt/sources.list" -d "$RLS"
29 fi
30 netselect-apt --arch "$RELEASE_ARCH" --sources "$netselect_string" --outfile "${ETC_DIR}/apt/sources.list" -d "$RLS"
32 netselect-apt --arch "$RELEASE_ARCH" --sources --nonfree --outfile "${ETC_DIR}/apt/sources.list" -d "$RELEASE"
33 else
34 netselect-apt --arch "$RELEASE_ARCH" --sources --outfile "${ETC_DIR}/apt/sources.list" -d "$RELEASE"
31 35 fi
32 36
33 37 # Upgrade package index and update all installed packages and changed dependencies
34 38 chroot_exec apt-get -qq -y update
35 39 chroot_exec apt-get -qq -y -u dist-upgrade
36 40
37 41 if [ "$APT_INCLUDES_LATE" ] ; then
38 42 chroot_exec apt-get -qq -y install "$(echo "$APT_INCLUDES_LATE" |tr , ' ')"
39 43 fi
40 44
41 45 if [ -d packages ] ; then
42 46 for package in packages/*.deb ; do
43 47 cp "$package" "${R}"/tmp
44 48 chroot_exec dpkg --unpack /tmp/"$(basename "$package")"
45 49 done
46 50 fi
47 51 chroot_exec apt-get -qq -y -f install
48 52
49 53 chroot_exec apt-get -qq -y check No newline at end of file
@@ -1,53 +1,52
1 1 #!/bin/bash
2 2 #
3 3 # Setup Firewall
4 4 #
5 5
6 6 # Load utility functions
7 7 . ./functions.sh
8 8
9 9 if [ "$ENABLE_IPTABLES" = true ] ; then
10 10 # Create iptables configuration directory
11 11 mkdir -p "${ETC_DIR}/iptables"
12 12
13 #In Jessie iptables is old enough
14 if ! [ "$RELEASE" = jessie ] ; then
15 13 # make sure iptables-legacy,iptables-legacy-restore and iptables-legacy-save are the used alternatives
16 14 chroot_exec update-alternatives --verbose --set iptables /usr/sbin/iptables-legacy
17 15 #chroot_exec update-alternatives --verbose --set iptables-save /usr/sbin/iptables-legacy-save
18 16 #chroot_exec update-alternatives --verbose --set iptables-restore /usr/sbin/iptables-legacy-restore
19 fi
17 chroot_exec update-alternatives --verbose --install /usr/sbin/iptables-save iptables-save /usr/sbin/iptables-legacy-save 1
18 chroot_exec update-alternatives --verbose --install /usr/sbin/iptables-restore iptables-restore /usr/sbin/iptables-legacy-restore 1
20 19
21 20 # Install iptables systemd service
22 21 install_readonly files/iptables/iptables.service "${ETC_DIR}/systemd/system/iptables.service"
23 22
24 23 # Install flush-table script called by iptables service
25 24 install_exec files/iptables/flush-iptables.sh "${ETC_DIR}/iptables/flush-iptables.sh"
26 25
27 26 # Install iptables rule file
28 27 install_readonly files/iptables/iptables.rules "${ETC_DIR}/iptables/iptables.rules"
29 28
30 29 # Reload systemd configuration and enable iptables service
31 30 chroot_exec systemctl daemon-reload
32 31 chroot_exec systemctl enable iptables.service
33 32
34 33 if [ "$ENABLE_IPV6" = true ] ; then
35 34 # Install ip6tables systemd service
36 35 install_readonly files/iptables/ip6tables.service "${ETC_DIR}/systemd/system/ip6tables.service"
37 36
38 37 # Install ip6tables file
39 38 install_exec files/iptables/flush-ip6tables.sh "${ETC_DIR}/iptables/flush-ip6tables.sh"
40 39
41 40 install_readonly files/iptables/ip6tables.rules "${ETC_DIR}/iptables/ip6tables.rules"
42 41
43 42 # Reload systemd configuration and enable iptables service
44 43 chroot_exec systemctl daemon-reload
45 44 chroot_exec systemctl enable ip6tables.service
46 45 fi
47 46
48 47 if [ "$ENABLE_SSHD" = false ] ; then
49 48 # Remove SSHD related iptables rules
50 49 sed -i "/^#/! {/SSH/ s/^/# /}" "${ETC_DIR}/iptables/iptables.rules" 2> /dev/null
51 50 sed -i "/^#/! {/SSH/ s/^/# /}" "${ETC_DIR}/iptables/ip6tables.rules" 2> /dev/null
52 51 fi
53 52 fi
@@ -1,768 +1,763
1 1 #!/bin/bash
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for RPi2/3
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 #Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 56 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 57
58 58 # Firmware directory: Blank if download from github
59 59 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
60 60
61 61 # Build directories
62 62 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
63 63 BUILDDIR="${BASEDIR}/build"
64 64
65 65 # Prepare date string for default image file name
66 66 DATE="$(date +%Y-%m-%d)"
67 67 if [ -z "$KERNEL_BRANCH" ] ; then
68 68 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
69 69 else
70 70 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
71 71 fi
72 72
73 73 # Chroot directories
74 74 R="${BUILDDIR}/chroot"
75 75 ETC_DIR="${R}/etc"
76 76 LIB_DIR="${R}/lib"
77 77 BOOT_DIR="${R}/boot/firmware"
78 78 KERNEL_DIR="${R}/usr/src/linux"
79 79 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
80 80
81 81 # General settings
82 82 SET_ARCH=${SET_ARCH:=32}
83 83 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
84 84 PASSWORD=${PASSWORD:=raspberry}
85 85 USER_PASSWORD=${USER_PASSWORD:=raspberry}
86 86 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
87 87 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
88 88 EXPANDROOT=${EXPANDROOT:=true}
89 89
90 90 # Keyboard settings
91 91 XKB_MODEL=${XKB_MODEL:=""}
92 92 XKB_LAYOUT=${XKB_LAYOUT:=""}
93 93 XKB_VARIANT=${XKB_VARIANT:=""}
94 94 XKB_OPTIONS=${XKB_OPTIONS:=""}
95 95
96 96 # Network settings (DHCP)
97 97 ENABLE_DHCP=${ENABLE_DHCP:=true}
98 98
99 99 # Network settings (static)
100 100 NET_ADDRESS=${NET_ADDRESS:=""}
101 101 NET_GATEWAY=${NET_GATEWAY:=""}
102 102 NET_DNS_1=${NET_DNS_1:=""}
103 103 NET_DNS_2=${NET_DNS_2:=""}
104 104 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
105 105 NET_NTP_1=${NET_NTP_1:=""}
106 106 NET_NTP_2=${NET_NTP_2:=""}
107 107
108 108 # APT settings
109 109 APT_PROXY=${APT_PROXY:=""}
110 110 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
111 111
112 112 # Feature settings
113 113 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
114 114 ENABLE_I2C=${ENABLE_I2C:=false}
115 115 ENABLE_SPI=${ENABLE_SPI:=false}
116 116 ENABLE_IPV6=${ENABLE_IPV6:=true}
117 117 ENABLE_SSHD=${ENABLE_SSHD:=true}
118 118 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
119 119 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
120 120 ENABLE_SOUND=${ENABLE_SOUND:=true}
121 121 ENABLE_DBUS=${ENABLE_DBUS:=true}
122 122 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
123 123 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
124 124 ENABLE_XORG=${ENABLE_XORG:=false}
125 125 ENABLE_WM=${ENABLE_WM:=""}
126 126 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
127 127 ENABLE_USER=${ENABLE_USER:=true}
128 128 USER_NAME=${USER_NAME:="pi"}
129 129 ENABLE_ROOT=${ENABLE_ROOT:=false}
130 130 ENABLE_QEMU=${ENABLE_QEMU:=false}
131 131
132 132 # SSH settings
133 133 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
134 134 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
135 135 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
136 136 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
137 137 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
138 138
139 139 # Advanced settings
140 140 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
141 141 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
142 142 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
143 143 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
144 144 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
145 145 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
146 146 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
147 147 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
148 148 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
149 149 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
150 150 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
151 151 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
152 152
153 153 # Kernel compilation settings
154 154 BUILD_KERNEL=${BUILD_KERNEL:=true}
155 155 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
156 156 KERNEL_THREADS=${KERNEL_THREADS:=1}
157 157 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
158 158 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
159 159 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
160 160 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
161 161 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
162 162
163 163 # Kernel compilation from source directory settings
164 164 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
165 165 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
166 166 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
167 167 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
168 168
169 169 # Reduce disk usage settings
170 170 REDUCE_APT=${REDUCE_APT:=true}
171 171 REDUCE_DOC=${REDUCE_DOC:=true}
172 172 REDUCE_MAN=${REDUCE_MAN:=true}
173 173 REDUCE_VIM=${REDUCE_VIM:=false}
174 174 REDUCE_BASH=${REDUCE_BASH:=false}
175 175 REDUCE_HWDB=${REDUCE_HWDB:=true}
176 176 REDUCE_SSHD=${REDUCE_SSHD:=true}
177 177 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
178 178
179 179 # Encrypted filesystem settings
180 180 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
181 181 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
182 182 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
183 183 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
184 184 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
185 185
186 186 # Chroot scripts directory
187 187 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
188 188
189 189 # Packages required in the chroot build environment
190 190 APT_INCLUDES=${APT_INCLUDES:=""}
191 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
191 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup"
192 192
193 193 # Packages required for bootstrapping
194 194 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
195 195 MISSING_PACKAGES=""
196 196
197 197 #autoselect best apt mirror
198 198 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} netselect-apt"
199 199
200 200 # Packages installed for c/c++ build environment in chroot (keep empty)
201 201 COMPILER_PACKAGES=""
202 202
203 203 set +x
204 204
205 205 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
206 206 if [ -n "$SET_ARCH" ] ; then
207 207 echo "Setting Architecture specific settings"
208 208 ##################################
209 209 # 64 bit config
210 210 ##################################
211 211 if [ "$SET_ARCH" = 64 ] ; then
212 212 echo "64 bit mode selected - Setting up enviroment"
213 213 # 64 bit depended settings
214 214 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
215 215 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
216 216 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
217 217 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
218 218 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
219 219 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
220 220
221 221 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
222 222 # RPI 3 serie specific settings
223 223 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
224 224 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
225 225
226 226 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
227 227 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
228 228 else
229 229 echo "error: At the moment Raspberry PI 3 and 3B+ are the only Models which support 64bit"
230 230 exit 1
231 231 fi
232 232 fi
233 233
234 234 ##################################
235 235 # 32 bit config
236 236 ##################################
237 237 if [ "$SET_ARCH" = 32 ] ; then
238 238 echo "32 bit mode selected - Setting up enviroment"
239 239 #General 32bit configuration
240 240 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
241 241 KERNEL_ARCH=${KERNEL_ARCH:=arm}
242 242 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
243 243
244 244 #Raspberry setting grouped by board compability
245 245 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
246 246 echo "Setting settings for bcm2835 Raspberry PI boards"
247 247 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
248 248 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
249 249 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
250 250 RELEASE_ARCH=${RELEASE_ARCH:=armel}
251 251 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
252 252 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
253 253 fi
254 254 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
255 255 echo "Setting settings for bcm2837 Raspberry PI boards"
256 256 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
257 257 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
258 258 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
259 259 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
260 260 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
261 261 fi
262 262
263 263 echo "Setting Raspberry PI $RPI_MODEL specific configuration"
264 264
265 265 #Device specific configuration
266 266 case "$RPI_MODEL" in
267 267 0)
268 268 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
269 269 ;;
270 270 1)
271 271 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
272 272 ;;
273 273 1P)
274 274 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
275 275 ;;
276 276 2)
277 277 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
278 278 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
279 279 ;;
280 280 3)
281 281 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
282 282 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
283 283 ;;
284 284 3P)
285 285 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
286 286 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_32b_defconfig}
287 287 ;;
288 288 *)
289 289 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
290 290 exit 1
291 291 ;;
292 292 esac
293 293
294 294 #end 32 bit
295 295 fi
296 296 #SET_ARCH not set
297 297 else
298 298 echo "error: Please set '32' or '64' as value for SET_ARCH"
299 299 exit 1
300 300 fi
301 301
302 302 # Check if the internal wireless interface is supported by the RPi model
303 303 if [ "$ENABLE_WIRELESS" = true ] ; then
304 304 if [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 2 ] ; then
305 305 echo "error: The selected Raspberry Pi model has no internal wireless interface"
306 306 exit 1
307 307 else
308 308 echo "Raspberry Pi model"
309 309 fi
310 310 fi
311 311
312 312 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
313 313 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
314 314 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
315 315 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
316 316 exit 1
317 317 fi
318 318 fi
319 319
320 320 # Add libncurses5 to enable kernel menuconfig
321 321 if [ "$KERNEL_MENUCONFIG" = true ] ; then
322 322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
323 323 fi
324 324
325 325 # Add ccache compiler cache for (faster) kernel cross (re)compilation
326 326 if [ "$KERNEL_CCACHE" = true ] ; then
327 327 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
328 328 fi
329 329
330 330 # Add cryptsetup package to enable filesystem encryption
331 331 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
332 332 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
333 333 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
334 334
335 335 if [ -z "$CRYPTFS_PASSWORD" ] ; then
336 336 echo "error: no password defined (CRYPTFS_PASSWORD)!"
337 337 exit 1
338 338 fi
339 339 ENABLE_INITRAMFS=true
340 340 fi
341 341
342 342 # Add initramfs generation tools
343 343 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
344 344 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
345 345 fi
346 346
347 347 # Add device-tree-compiler required for building the U-Boot bootloader
348 348 if [ "$ENABLE_UBOOT" = true ] ; then
349 349 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
350 350 fi
351 351
352 352 # Check if root SSH (v2) public key file exists
353 353 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
354 354 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
355 355 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
356 356 exit 1
357 357 fi
358 358 fi
359 359
360 360 # Check if $USER_NAME SSH (v2) public key file exists
361 361 if [ -n "$SSH_USER_PUB_KEY" ] ; then
362 362 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
363 363 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
364 364 exit 1
365 365 fi
366 366 fi
367 367
368 368 # Check if all required packages are installed on the build system
369 369 for package in $REQUIRED_PACKAGES ; do
370 370 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
371 371 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
372 372 fi
373 373 done
374 374
375 375 # If there are missing packages ask confirmation for install, or exit
376 376 if [ -n "$MISSING_PACKAGES" ] ; then
377 377 echo "the following packages needed by this script are not installed:"
378 378 echo "$MISSING_PACKAGES"
379 379
380 380 printf "\ndo you want to install the missing packages right now? [y/n] "
381 381 read -r confirm
382 382 [ "$confirm" != "y" ] && exit 1
383 383
384 384 # Make sure all missing required packages are installed
385 385 apt-get -qq -y install "${MISSING_PACKAGES}"
386 386 fi
387 387
388 388 # Check if ./bootstrap.d directory exists
389 389 if [ ! -d "./bootstrap.d/" ] ; then
390 390 echo "error: './bootstrap.d' required directory not found!"
391 391 exit 1
392 392 fi
393 393
394 394 # Check if ./files directory exists
395 395 if [ ! -d "./files/" ] ; then
396 396 echo "error: './files' required directory not found!"
397 397 exit 1
398 398 fi
399 399
400 400 # Check if specified KERNELSRC_DIR directory exists
401 401 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
402 402 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
403 403 exit 1
404 404 fi
405 405
406 406 # Check if specified UBOOTSRC_DIR directory exists
407 407 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
408 408 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
409 409 exit 1
410 410 fi
411 411
412 412 # Check if specified FBTURBOSRC_DIR directory exists
413 413 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
414 414 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
415 415 exit 1
416 416 fi
417 417
418 418 # Check if specified CHROOT_SCRIPTS directory exists
419 419 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
420 420 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
421 421 exit 1
422 422 fi
423 423
424 424 # Check if specified device mapping already exists (will be used by cryptsetup)
425 425 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
426 426 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
427 427 exit 1
428 428 fi
429 429
430 430 # Don't clobber an old build
431 431 if [ -e "$BUILDDIR" ] ; then
432 432 echo "error: directory ${BUILDDIR} already exists, not proceeding"
433 433 exit 1
434 434 fi
435 435
436 436 # Setup chroot directory
437 437 mkdir -p "${R}"
438 438
439 439 # Check if build directory has enough of free disk space >512MB
440 440 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
441 441 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
442 442 exit 1
443 443 fi
444 444
445 445 set -x
446 446
447 447 # Call "cleanup" function on various signals and errors
448 448 trap cleanup 0 1 2 3 6
449 449
450 450 # Add required packages for the minbase installation
451 451 if [ "$ENABLE_MINBASE" = true ] ; then
452 452 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
453 453 fi
454 454
455 # Add required locales packages
456 if [ "$DEFLOCAL" != "en_US.UTF-8" ] || { [ -n "$XKB_MODEL" ] || [ -n "$XKB_LAYOUT" ] || [ -n "$XKB_VARIANT" ] || [ -n "$XKB_OPTIONS" ] ; } ; then
457 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
458 fi
459
460 455 # Add parted package, required to get partprobe utility
461 456 if [ "$EXPANDROOT" = true ] ; then
462 457 APT_INCLUDES="${APT_INCLUDES},parted"
463 458 fi
464 459
465 460 # Add dbus package, recommended if using systemd
466 461 if [ "$ENABLE_DBUS" = true ] ; then
467 462 APT_INCLUDES="${APT_INCLUDES},dbus"
468 463 fi
469 464
470 465 # Add iptables IPv4/IPv6 package
471 466 if [ "$ENABLE_IPTABLES" = true ] ; then
472 467 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
473 468 fi
474 469
475 470 # Add openssh server package
476 471 if [ "$ENABLE_SSHD" = true ] ; then
477 472 APT_INCLUDES="${APT_INCLUDES},openssh-server"
478 473 fi
479 474
480 475 # Add alsa-utils package
481 476 if [ "$ENABLE_SOUND" = true ] ; then
482 477 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
483 478 fi
484 479
485 480 # Add rng-tools package
486 481 if [ "$ENABLE_HWRANDOM" = true ] ; then
487 482 APT_INCLUDES="${APT_INCLUDES},rng-tools"
488 483 fi
489 484
490 485 # Add fbturbo video driver
491 486 if [ "$ENABLE_FBTURBO" = true ] ; then
492 487 # Enable xorg package dependencies
493 488 ENABLE_XORG=true
494 489 fi
495 490
496 491 # Add user defined window manager package
497 492 if [ -n "$ENABLE_WM" ] ; then
498 493 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
499 494
500 495 # Enable xorg package dependencies
501 496 ENABLE_XORG=true
502 497 fi
503 498
504 499 # Add xorg package
505 500 if [ "$ENABLE_XORG" = true ] ; then
506 501 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
507 502 fi
508 503
509 504 # Replace selected packages with smaller clones
510 505 if [ "$ENABLE_REDUCE" = true ] ; then
511 506 # Add levee package instead of vim-tiny
512 507 if [ "$REDUCE_VIM" = true ] ; then
513 508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
514 509 fi
515 510
516 511 # Add dropbear package instead of openssh-server
517 512 if [ "$REDUCE_SSHD" = true ] ; then
518 513 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
519 514 fi
520 515 fi
521 516
522 517 # Configure kernel sources if no KERNELSRC_DIR
523 518 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
524 519 KERNELSRC_CONFIG=true
525 520 fi
526 521
527 522 # Configure reduced kernel
528 523 if [ "$KERNEL_REDUCE" = true ] ; then
529 524 KERNELSRC_CONFIG=false
530 525 fi
531 526
532 527 # Execute bootstrap scripts
533 528 for SCRIPT in bootstrap.d/*.sh; do
534 529 head -n 3 "$SCRIPT"
535 530 . "$SCRIPT"
536 531 done
537 532
538 533 ## Execute custom bootstrap scripts
539 534 if [ -d "custom.d" ] ; then
540 535 for SCRIPT in custom.d/*.sh; do
541 536 . "$SCRIPT"
542 537 done
543 538 fi
544 539
545 540 # Execute custom scripts inside the chroot
546 541 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
547 542 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
548 543 chroot_exec /bin/bash -x <<'EOF'
549 544 for SCRIPT in /chroot_scripts/* ; do
550 545 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
551 546 $SCRIPT
552 547 fi
553 548 done
554 549 EOF
555 550 rm -rf "${R}/chroot_scripts"
556 551 fi
557 552
558 553 # Remove c/c++ build environment from the chroot
559 554 chroot_remove_cc
560 555
561 556 # Generate required machine-id
562 557 MACHINE_ID=$(dbus-uuidgen)
563 558 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
564 559 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
565 560
566 561 # APT Cleanup
567 562 chroot_exec apt-get -y clean
568 563 chroot_exec apt-get -y autoclean
569 564 chroot_exec apt-get -y autoremove
570 565
571 566 # Unmount mounted filesystems
572 567 umount -l "${R}/proc"
573 568 umount -l "${R}/sys"
574 569
575 570 # Clean up directories
576 571 rm -rf "${R}/run/*"
577 572 rm -rf "${R}/tmp/*"
578 573
579 574 # Clean up files
580 575 rm -f "${ETC_DIR}/ssh/ssh_host_*"
581 576 rm -f "${ETC_DIR}/dropbear/dropbear_*"
582 577 rm -f "${ETC_DIR}/apt/sources.list.save"
583 578 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
584 579 rm -f "${ETC_DIR}/*-"
585 580 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
586 581 rm -f "${ETC_DIR}/resolv.conf"
587 582 rm -f "${R}/root/.bash_history"
588 583 rm -f "${R}/var/lib/urandom/random-seed"
589 584 rm -f "${R}/initrd.img"
590 585 rm -f "${R}/vmlinuz"
591 586 rm -f "${R}${QEMU_BINARY}"
592 587
593 588 if [ "$ENABLE_QEMU" = true ] ; then
594 589 # Configure qemu compatible kernel
595 590 DTB_FILE=vexpress-v2p-ca15_a7.dtb
596 591 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
597 592 KERNEL_DEFCONFIG="vexpress_defconfig"
598 593 if [ "$KERNEL_MENUCONFIG" = false ] ; then
599 594 KERNEL_OLDDEFCONFIG=true
600 595 fi
601 596
602 597 # Setup QEMU directory
603 598 mkdir "${BASEDIR}/qemu"
604 599
605 600 # Copy kernel image to QEMU directory
606 601 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
607 602
608 603 # Copy kernel config to QEMU directory
609 604 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
610 605
611 606 # Copy kernel dtbs to QEMU directory
612 607 for dtb in "${BOOT_DIR}/"*.dtb ; do
613 608 if [ -f "${dtb}" ] ; then
614 609 install_readonly "${dtb}" "${BASEDIR}/qemu/"
615 610 fi
616 611 done
617 612
618 613 # Copy kernel overlays to QEMU directory
619 614 if [ -d "${BOOT_DIR}/overlays" ] ; then
620 615 # Setup overlays dtbs directory
621 616 mkdir "${BASEDIR}/qemu/overlays"
622 617
623 618 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
624 619 if [ -f "${dtb}" ] ; then
625 620 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
626 621 fi
627 622 done
628 623 fi
629 624
630 625 # Copy u-boot files to QEMU directory
631 626 if [ "$ENABLE_UBOOT" = true ] ; then
632 627 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
633 628 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
634 629 fi
635 630 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
636 631 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
637 632 fi
638 633 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
639 634 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
640 635 fi
641 636 fi
642 637
643 638 # Copy initramfs to QEMU directory
644 639 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
645 640 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
646 641 fi
647 642 fi
648 643
649 644 # Calculate size of the chroot directory in KB
650 645 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
651 646
652 647 # Calculate the amount of needed 512 Byte sectors
653 648 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
654 649 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
655 650 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
656 651
657 652 # The root partition is EXT4
658 653 # This means more space than the actual used space of the chroot is used.
659 654 # As overhead for journaling and reserved blocks 35% are added.
660 655 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
661 656
662 657 # Calculate required image size in 512 Byte sectors
663 658 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
664 659
665 660 # Prepare image file
666 661 if [ "$ENABLE_SPLITFS" = true ] ; then
667 662 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
668 663 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
669 664 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
670 665 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
671 666
672 667 # Write firmware/boot partition tables
673 668 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
674 669 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
675 670 EOM
676 671
677 672 # Write root partition table
678 673 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
679 674 "${TABLE_SECTORS}","${ROOT_SECTORS}",83
680 675 EOM
681 676
682 677 # Setup temporary loop devices
683 678 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
684 679 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
685 680 else # ENABLE_SPLITFS=false
686 681 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
687 682 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
688 683
689 684 # Write partition table
690 685 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
691 686 "${TABLE_SECTORS}","${FRMW_SECTORS}",c,*
692 687 "${ROOT_OFFSET}","${ROOT_SECTORS}",83
693 688 EOM
694 689
695 690 # Setup temporary loop devices
696 691 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
697 692 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
698 693 fi
699 694
700 695 if [ "$ENABLE_CRYPTFS" = true ] ; then
701 696 # Create dummy ext4 fs
702 697 mkfs.ext4 "$ROOT_LOOP"
703 698
704 699 # Setup password keyfile
705 700 touch .password
706 701 chmod 600 .password
707 702 echo -n "${CRYPTFS_PASSWORD}" > .password
708 703
709 704 # Initialize encrypted partition
710 705 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
711 706
712 707 # Open encrypted partition and setup mapping
713 708 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
714 709
715 710 # Secure delete password keyfile
716 711 shred -zu .password
717 712
718 713 # Update temporary loop device
719 714 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
720 715
721 716 # Wipe encrypted partition (encryption cipher is used for randomness)
722 717 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
723 718 fi
724 719
725 720 # Build filesystems
726 721 mkfs.vfat "$FRMW_LOOP"
727 722 mkfs.ext4 "$ROOT_LOOP"
728 723
729 724 # Mount the temporary loop devices
730 725 mkdir -p "$BUILDDIR/mount"
731 726 mount "$ROOT_LOOP" "$BUILDDIR/mount"
732 727
733 728 mkdir -p "$BUILDDIR/mount/boot/firmware"
734 729 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
735 730
736 731 # Copy all files from the chroot to the loop device mount point directory
737 732 rsync -a "${R}/" "$BUILDDIR/mount/"
738 733
739 734 # Unmount all temporary loop devices and mount points
740 735 cleanup
741 736
742 737 # Create block map file(s) of image(s)
743 738 if [ "$ENABLE_SPLITFS" = true ] ; then
744 739 # Create block map files for "bmaptool"
745 740 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
746 741 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
747 742
748 743 # Image was successfully created
749 744 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
750 745 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
751 746 else
752 747 # Create block map file for "bmaptool"
753 748 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
754 749
755 750 # Image was successfully created
756 751 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
757 752
758 753 # Create qemu qcow2 image
759 754 if [ "$ENABLE_QEMU" = true ] ; then
760 755 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
761 756 QEMU_SIZE=16G
762 757
763 758 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
764 759 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
765 760
766 761 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
767 762 fi
768 763 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant